<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <script src="{{ url_for('static' , filename = '/js/jquery-3.6.0.min.js')}}"></script>
    <title>Javascript - Cookies</title>
  </head>
  <body>
    <h1>Javascript - Cookies</h1>

    <h3>Example :</h3>
    <ul>
      <li>1. account : DevAuth</li>
      <li>2. isRememberMe : true</li>
      <li>3. shoppingCart : 1,2,3,4,5</li>
      <li>4. buyNextTime : 6,7,8,9,10</li>
      <li>5. queryRecord : Cookie,Session</li>
    </ul>

    <p>key : <input type="text" id="edtKey" /></p>
    <p>value : <input type="text" id="edtValue" /></p>
    <button id="btnSave">Save</button>
    <button id="btnRead">Read</button>
    <button id="btnDelete">Delete</button>
    <hr />
    <h3>Result :</h3>
    <div id="console"></div>
    <hr />
    <h3>Data :</h3>
    <div id="data"></div>
    <hr />
    <h3>Login :</h3>
    帳號 : <input id="edtAc" type="text" />
    <input id="chkRememberMe" type="checkbox" />記住我<br />
    密碼 : <input id="edtPw" type="password" />
    <button id="btnLogin">Login</button>

    <script>
      $(function () {
        var $edtKey = $("#edtKey");
        var $edtValue = $("#edtValue");

        var $btnSave = $("#btnSave");
        var $btnRead = $("#btnRead");
        var $btnDelete = $("#btnDelete");

        var $console = $("#console");
        var $data = $("#data");

        var $edtAccount = $("#edtAc");
        var $edtPassword = $("#edtPw");
        var $chkRememberMe = $("#chkRememberMe");
        var $btnLogin = $("#btnLogin");

        var lstData = [];

        $btnSave.off("click").on("click", function () {
          var key = $edtKey.val();
          var val = $edtValue.val();
          createCookie(key, val, 1);

          $edtKey.val("");
          $edtValue.val("");
          $console.text("OK");
          showCookie();
          showLoginInfo();
        });

        $btnRead.off("click").on("click", function () {
          var key = $edtKey.val();
          let val = readCookie(key);

          $edtKey.val("");
          $edtValue.val("");
          $console.text("key = " + key + " , value = " + val);

          showCookie();
          showLoginInfo();
        });

        $btnDelete.off("click").on("click", function () {
          let key = $edtKey.val();
          let val = eraseCookie(key);

          $edtKey.val("");
          $edtValue.val("");
          $console.text("OK");

          showCookie();
          showLoginInfo();
        });

        $btnLogin.off("click").on("click", function () {
          let account = $edtAccount.val();
          let isRememberMe = $chkRememberMe.prop("checked");

          if (isRememberMe) {
            createCookie("account", account, 1);
            createCookie("isRememberMe", isRememberMe, 1);
            showCookie();
            showLoginInfo();
          } else {
            eraseCookie("account");
            eraseCookie("isRememberMe");
            showCookie();
            showLoginInfo();
          }

          alert("OK");
        });

        // 建立cookie
        function createCookie(name, value, days) {
          var expires = "";
          if (days) {
            var date = new Date();
            date.setTime(date.getTime() + days * 24 * 60 * 60 * 1000);
            var expires = "; expires=" + date.toGMTString();
          }
          document.cookie = name + "=" + value + expires + "; path=/";
        }
        //讀取
        function readCookie(name) {
          var key = name + "=";
          var cookie = document.cookie.split("; ");
          var value = "";
          for (var i = 0; i < cookie.length; i++) {
            var param = cookie[i];
            if (param.indexOf(key) == 0) {
              value = param.substring(key.length, param.length);
            }
          }
          return value;
        }

        //刪除
        function eraseCookie(name) {
          createCookie(name, "", -1);
        }

        function showCookie() {
          $data.html("");
          lstData = [];
          var cookie = document.cookie.split("; ");

          for (var i = 0; i < cookie.length; i++) {
            var btnSelect =
              "<button name='btnSelect' value=" + i + ">Select</butotn>";
            var data = cookie[i];
            if (data.indexOf("=") != -1) {
              var arr = data.split("=");
              lstData.push({ key: arr[0], val: arr[1] });
              $data.append(btnSelect);
              $data.append(" ");
              $data.append(data);
              $data.append("<br>");
            }
          }

          var $btnSelect = $("[name=btnSelect]");
          $btnSelect.off("click").on("click", function () {
            let idx = $(this).val();
            $edtKey.val(lstData[idx].key);
          });
        }

        function showLoginInfo() {
          let account = readCookie("account");
          let isRememberMe = readCookie("isRememberMe") == "true";
          
          if (isRememberMe) {
            $edtAccount.val(account);
          } else {
            $edtAccount.val("");
          }

          $chkRememberMe.prop("checked", isRememberMe);
          $edtPassword.val("");
        }

        showLoginInfo();
        showCookie();
      });
    </script>
  </body>
</html>
